﻿Imports System.Console

Module Module1
    Structure Igény
        Dim óra, perc, másodperc, csapat, honnan, hová As Integer
    End Structure

    Dim igények(100) As Igény
    Dim szintszám, csapatszám, igényszám As Integer
    Dim indulószint
    Dim véletlencsapat As Integer

    Sub Main()
        Randomize()

        Feladat1()
        Feladat2()
        Feladat3()
        Feladat4()
        Feladat5()
        Feladat6()
        Feladat7()
        Feladat8()

        ReadLine()
    End Sub

    Sub Feladat1()
        Dim fájl As IO.FileStream = New IO.FileStream("..\..\igeny.txt", IO.FileMode.Open)
        Dim olvasó As IO.StreamReader = New IO.StreamReader(fájl)
        Dim egysor(6) As String

        WriteLine("1. Adatok beolvasása")
        WriteLine()

        szintszám = olvasó.ReadLine
        csapatszám = olvasó.ReadLine
        igényszám = olvasó.ReadLine

        For i As Integer = 1 To igényszám
            egysor = olvasó.ReadLine.Split(" ")
            With igények(i)
                .óra = egysor(0)
                .perc = egysor(1)
                .másodperc = egysor(2)
                .csapat = egysor(3)
                .honnan = egysor(4)
                .hová = egysor(5)
            End With
        Next
        olvasó.Close()
        fájl.Close()
    End Sub

    Sub Feladat2()
        Write("2. Adja meg, kezdetben melyik szinten áll a lift = ")
        indulószint = ReadLine()
        WriteLine()
    End Sub

    Sub Feladat3()
        WriteLine("3. A lift a " & igények(igényszám).hová & " szinten áll az utolsó igény teljesítése után.")
        WriteLine()
    End Sub

    Sub Feladat4()
        Dim minszint, maxszint As Integer

        'Minimum/maximum
        minszint = indulószint    'Nem az első igény szintjéről indul!
        maxszint = indulószint
        For i As Integer = 1 To igényszám
            If minszint > igények(i).honnan Then
                minszint = igények(i).honnan
            End If
            If minszint > igények(i).hová Then
                minszint = igények(i).hová
            End If
            If maxszint < igények(i).honnan Then
                maxszint = igények(i).honnan
            End If
            If maxszint < igények(i).hová Then
                maxszint = igények(i).hová
            End If
        Next

        WriteLine("4. A lift legalacsonyabb szintje=" & minszint & " legmagasabb szintje=" & maxszint)
        WriteLine()
    End Sub

    Sub Feladat5()
        Dim tele As Integer = 0
        Dim üresen As Integer = 0
        Dim előzőszint As Integer = indulószint

        'Megszámlálás
        For i As Integer = 1 To igényszám
            If előzőszint < igények(i).honnan Then
                üresen = üresen + 1
            End If
            If igények(i).honnan < igények(i).hová Then
                tele = tele + 1
            End If
            előzőszint = igények(i).hová
        Next

        WriteLine("5. A lift üresen megy fel " & üresen & " alkalommal, és utassal " & tele & " alkalommal.")
        WriteLine()
    End Sub

    Sub Feladat6()
        Dim darab(csapatszám) As Integer
        Write("6. A liftet nem vették igénybe: ")

        'Megszámlálás
        For i As Integer = 1 To igényszám
            darab(igények(i).csapat) = darab(igények(i).csapat) + 1
        Next

        For i As Integer = 1 To csapatszám
            If darab(i) = 0 Then
                Write(i & " ")
            End If
        Next

        WriteLine()
        WriteLine()
    End Sub


    Sub Feladat7()
        Dim holvanéppen As Integer = -1         'Kezdetben nem tudjuk hol van
        Dim csalte As Boolean = False

        'véletlencsapat = Int(Rnd() * csapatokszáma) + 1
        véletlencsapat = 3
        WriteLine("7. Kiválasztott csapat=" & véletlencsapat)

        For i As Integer = 1 To igényszám
            If igények(i).csapat = véletlencsapat Then
                If holvanéppen = -1 Then
                    holvanéppen = igények(i).hová
                Else
                    If holvanéppen <> igények(i).honnan Then
                        WriteLine("Csalás az " & i & ". igénynél, lement a " & holvanéppen & "->" & igények(i).honnan)
                        csalte = True
                    End If
                End If
                holvanéppen = igények(i).hová
            End If
        Next
        If csalte = False Then
            WriteLine("Nem állapítható meg csalás")
        End If

        WriteLine()
    End Sub

    Sub Feladat8()
        Dim fájl As IO.FileStream = New IO.FileStream("..\..\blokkol.txt", IO.FileMode.Create)
        Dim író As IO.StreamWriter = New IO.StreamWriter(fájl)

        For i As Integer = 1 To igényszám
            If igények(i).csapat = véletlencsapat Then
                WriteLine("Befejezés ideje: " & igények(i).óra & ":" & igények(i).perc & ":" & igények(i).másodperc)
                író.WriteLine("Befejezés ideje: " & igények(i).óra & ":" & igények(i).perc & ":" & igények(i).másodperc)
                Write("Sikeresség=")
                Dim sikeresség As String = ReadLine()
                író.WriteLine("Sikeresség: " & sikeresség)
                WriteLine("-----")
                író.WriteLine("-----")
                WriteLine("Indulási emelelet: " & igények(i).honnan)
                író.WriteLine("Indulási emelelet: " & igények(i).honnan)
                WriteLine("Célemelet: " & igények(i).hová)
                író.WriteLine("Célemelet: " & igények(i).hová)
                Write("Feladatkód=")
                Dim feladatkód As Integer = ReadLine()
                író.WriteLine("Feladatkód: " & feladatkód)
            End If
        Next
        író.Close()
        fájl.Close()
    End Sub

End Module
